import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkAuthGroupAccess, ThinkAuthGroupAccessParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkAuthGroupAccess(
  params: ThinkAuthGroupAccessParam
) {
  const res = await request.get<ApiResult<PageResult<ThinkAuthGroupAccess>>>(
    THINK_API_URL + '/think/think-auth-group-access/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkAuthGroupAccess(
  params?: ThinkAuthGroupAccessParam
) {
  const res = await request.get<ApiResult<ThinkAuthGroupAccess[]>>(
    THINK_API_URL + '/think/think-auth-group-access',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkAuthGroupAccess(data: ThinkAuthGroupAccess) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-auth-group-access',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkAuthGroupAccess(data: ThinkAuthGroupAccess) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-auth-group-access',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkAuthGroupAccess(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-auth-group-access/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkAuthGroupAccess(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-auth-group-access/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkAuthGroupAccess(id: number) {
  const res = await request.get<ApiResult<ThinkAuthGroupAccess>>(
    THINK_API_URL + '/think/think-auth-group-access/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
